"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _traverse = _interopRequireDefault(require("@babel/traverse"));

var types = _interopRequireWildcard(require("@babel/types"));

var _utils = require("./utils");

var astUtil = _interopRequireWildcard(require("./utils/ast"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _default = function _default() {
  return {
    name: 'babel-plugin-jsx-sfc',
    visitor: {
      Program: function Program(_path, state) {
        (0, _traverse["default"])(_path.node, {
          /*
            const App = sfc(
              {
                template({ data }) {
                  ...
                },
            
                Component: (props) => {
                  ...
                },
            
                style: () => ({
                  ...
                })
              },
              {
                ...
              }
            );
              ↓ ↓ ↓ ↓ ↓ ↓ 
              const App = sfc((props) => { ... }, [
              {
                template({ data }) {
                  ...
                },
            
                style: () => ({
                  ...
                })
              },
              {
                ...
              }
            ]);
          */
          CallExpression: {
            enter: function enter(path) {
              var _state$opts;

              var callee = path.node.callee;
              var importedLib = state === null || state === void 0 ? void 0 : (_state$opts = state.opts) === null || _state$opts === void 0 ? void 0 : _state$opts.importedLib;

              if (types.isCallExpression(callee) && astUtil.isCalleeImportedBySfc(callee.callee, path, importedLib) || astUtil.isCalleeImportedBySfc(callee, path, importedLib)) {
                var sfcArguments = path.node.arguments;

                if (types.isObjectExpression(sfcArguments === null || sfcArguments === void 0 ? void 0 : sfcArguments[0])) {
                  var ComponentProp = sfcArguments[0].properties.find(function (prop) {
                    return types.isObjectProperty(prop) && types.isIdentifier(prop.key) && prop.key.name === _utils.SFC_COMPONENT;
                  });

                  if (!ComponentProp) {
                    return;
                  }

                  sfcArguments[0].properties.splice(sfcArguments[0].properties.indexOf(ComponentProp), 1);
                  path.replaceWith(types.callExpression(types.identifier(_utils.SFC_FUNC), [ComponentProp.value, types.arrayExpression(sfcArguments)]));
                }
              }
            }
          }
        });
      }
    }
  };
};

exports["default"] = _default;